const gameServerVersion = "0.0.5";

cc.gameServer = {
serverUrl: "https://www.huochairen.icu/sgame",
_fullrequest: "",
gameName: "",
appId: "",
splitweb() {
if ("" == this.appId) {
Editor.log("请输入正确的appid");
return "";
}
if ("" == this.gameName) {
Editor.log("请输入正确的游戏名");
return "";
}
return this.serverUrl + "?appid=" + this.appId + "&name=" + this.gameName;
},
GetData(e, t) {
return new Promise((r, a) => {
if ("" != e && null != e && "undefined" != typeof e) if (0 != this.parseTTAppId(e)) if ("" != t && null != t && "undefined" != typeof t) {
this.appId = e;
this.gameName = t;
this._fullrequest = this.splitweb();
"" != this._fullrequest ? cc.httpBase.httpPost(this.serverUrl, "appid=" + this.appId + "&name=" + this.gameName, e => {
-1 == e || -2 == e ? a("[cc.gameServer.GetData] : 链接网络出现错误") : r(e);
}) : a("[cc.gameServer.GetData] : 请输入正确的AppId和Name");
} else a("[cc.gameServer.GetData] : 请输入游戏名字 , 不能置空"); else a("[cc.gameServer.GetData] : 请输入正确格式的AppId [" + e + "] , 检查是否是 ttxxxxxxxxxxxxxxxx 格式(以tt开头 后跟小写和数字混合的16位字符 , 不能有大写字母)"); else a("[cc.gameServer.GetData] : 请输入游戏AppId , 不能置空");
});
},
parseTTAppId: e => null != e.match("^tt[a-z0-9]{16}$")
};

cc.rankServer = {
serverUrl: "https://www.huochairen.icu/rank",
GetHelpInfo() {
return new Promise((e, t) => {
cc.httpBase.httpPost(this.serverUrl, "type=help", r => {
-1 == r || -2 == r ? t("[cc.rankServer.GetHelpInfo] : 链接网络出现错误") : e(r);
});
});
},
GetAllRank(e, t) {
return new Promise((r, a) => {
"" != e ? this.isIntNumber(t) ? t <= 0 ? a("[cc.rankServer.GetAllRank] : 填写的数字必须大于 0") : cc.httpBase.httpPost(this.serverUrl, "type=getall&name=" + e + "&rn=" + t, e => {
-1 == e || -2 == e ? a("[cc.rankServer.GetAllRank] : 链接网络出现错误") : r(e);
}) : a("[cc.rankServer.GetAllRank] : 返回的数量为整数数字类型 , 请正确填写为 0 以上的整数数字") : a("[cc.rankServer.GetAllRank] : 游戏名不能为空");
});
},
SubMitRank(e, t, r, a, n, p) {
return new Promise((s, c) => {
"" != e ? "" != t ? this.isIntNumber(p) ? p <= 0 ? c("[cc.rankServer.SubMitRank] : 填写的分数必须大于 0") : cc.httpBase.httpPost(this.serverUrl, "type=submit&name=" + e + "&uid=" + t + "&au=" + r + "&nn=" + a + "&plat=" + n + "&s=" + p, e => {
-1 == e || -2 == e ? c("[cc.rankServer.SubMitRank] : 链接网络出现错误") : s(e);
}) : c("[cc.rankServer.SubMitRank] : 请正确填写分数为 0 以上的整数数字") : c("[cc.rankServer.SubMitRank] : 用户ID不能为空") : c("[cc.rankServer.SubMitRank] : 游戏名不能为空");
});
},
GetUserInfo(e, t) {
return new Promise((r, a) => {
"" != e ? "" != t ? cc.httpBase.httpPost(this.serverUrl, "type=user&name=" + e + "&uid=" + t, e => {
-1 == e || -2 == e ? a("[cc.rankServer.GetUserInfo] : 链接网络出现错误") : r(e);
}) : a("[cc.rankServer.GetUserInfo] : 用户ID不能为空") : a("[cc.rankServer.GetUserInfo] : 游戏名不能为空");
});
},
isIntNumber: e => !isNaN(e) && Math.floor(e) == e
};

cc.miniGameServer = {
serverUrl: "https://www.huochairen.icu/tt",
GetOpenID(e, t) {
return new Promise((r, a) => {
"" != e ? "undefined" != typeof e ? "undefined" != typeof t ? cc.gameServer.parseTTAppId(e) ? "" != t ? cc.httpBase.httpGets(this.serverUrl + "?type=uid&aid=" + e + "&ucode=" + t, e => {
-1 == e || -2 == e ? a("[cc.miniGameServer.GetOpenID] : 链接网络出现错误") : r(e);
}) : a("[cc.miniGameServer.GetOpenID] : ucode不能为空") : a("[cc.miniGameServer.GetOpenID] : 无效的AppID") : a("[cc.miniGameServer.GetOpenID] : 无效的用户ID") : a("[cc.miniGameServer.GetOpenID] : 无效的AppID") : a("[cc.miniGameServer.GetOpenID] : AppId不能为空");
});
},
SubAppSecret(e, t, r) {
return new Promise((a, n) => {
"" != e ? "undefined" != typeof appid ? "undefined" != typeof t ? "undefined" != typeof r ? cc.gameServer.parseTTAppId(appid) ? "" != t ? "" != r ? cc.httpBase.httpGets(this.serverUrl + "?type=subapp&aid=" + e + "&an=" + t + "&aset=" + r, e => {
-1 == e || -2 == e ? n("[cc.miniGameServer.SubAppSecret] : 链接网络出现错误") : a(e);
}) : n("[cc.miniGameServer.SubAppSecret] : AppSecret不能为空") : n("[cc.miniGameServer.SubAppSecret] : AppName不能为空") : n("[cc.miniGameServer.SubAppSecret] : 无效的AppID") : n("[cc.miniGameServer.SubAppSecret] : 无效的秘钥") : n("[cc.miniGameServer.SubAppSecret] : 无效的游戏名") : n("[cc.miniGameServer.SubAppSecret] : 无效的AppID") : n("[cc.miniGameServer.SubAppSecret] : AppId不能为空");
});
}
};

cc.httpBase = {
httpGets: function(e, t) {
var r = cc.loader.getXMLHttpRequest();
r.onreadystatechange = function() {
if (4 === r.readyState && r.status >= 200 && r.status < 300) {
var e = r.responseText;
t(JSON.parse(e));
} else r.status >= 400 && t(-2);
};
r.open("GET", e, !0);
r.timeout = 1e4;
r.onerror = function() {
console.log(e, " geterror ", r.statusText);
console.log(e, " geterror2 ", r.responseText);
console.log(e, " geterror3 ", r.status);
t(-1);
};
r.send();
},
httpPost: function(e, t, r) {
var a = cc.loader.getXMLHttpRequest();
a.onreadystatechange = function() {
if (4 === a.readyState && a.status >= 200 && a.status < 300) {
var e = a.responseText;
r(JSON.parse(e));
} else a.status >= 400 && r(-2);
};
a.open("POST", e, !0);
a.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
a.timeout = 5e4;
a.send(t);
},
httpUploadFile: function(e, t, r) {
var a = cc.loader.getXMLHttpRequest();
a.onreadystatechange = function() {
if (4 === a.readyState && a.status >= 200 && a.status < 300) {
var e = a.responseText;
r(e);
} else a.status >= 400 && r(-2);
};
for (var n = atob(t), p = [], s = 0; s < n.length; s++) p.push(n.charCodeAt(s));
var c = new Blob([ new Uint8Array(p) ], {
type: "image/png"
}), i = new FormData();
i.append("file", c, Date.now() + ".jpg");
a.open("POST", e, !0);
a.setRequestHeader("Access-Control-Allow-Origin", "*");
a.timeout = 5e3;
a.send(i);
}
};